<div class="responsive-table">
  <div fxLayout="row">
    <div fxLayoutGap="15px">
      <button *ngIf="phaseTitle != otherTasks && phaseStatus != completedStatus && hasPermission(addTasksPermission) "
        mat-raised-button color="primary" [routerLink]="['/project/task/add', selectedPhaseId]">
        <mat-icon>add</mat-icon>
        {{'créer ticket' | translate}}
      </button>
      <button mat-raised-button color="primary" (click)="togglePanel()" *ngIf="groupedTasks.length > 0">
        <mat-icon>filter_list</mat-icon>
        {{'filtrer' | translate}}
      </button>
      <button *ngIf="phaseTitle != backlog && groupedTasks.length > 0" matTooltip="Tableau des tâches" class="view" mat-raised-button
        color="primary" [routerLink]="['/project/phase/board', selectedPhaseId]">
        <mat-icon>view_module</mat-icon>Scrumboard
      </button>
    </div>
    <div class="ml-auto" fxLayoutGap="12px">
      <div fxFlex.gt-md="50">
        <mat-form-field appearance="outline" class="search-button" *ngIf="groupedTasks.length > 0">
          <input matInput placeholder="{{'Rechercher Ticket' | translate}}" (keyup)="applyFilter($event.target.value)" />
          <mat-icon class="icon-size" matSuffix>search</mat-icon>
        </mat-form-field>
      </div>
      <span>
        <button matTooltip="Cacher/Afficher des colonnes" mat-raised-button color="accent" #menuTrigger="matMenuTrigger"
          [matMenuTriggerFor]="mainMenuButton">
          <mat-icon>view_list</mat-icon>Colonnes
        </button>
      </span>
    </div>
    <mat-menu #mainMenuButton="matMenu">
      <span (click)="$event.stopPropagation()" *ngFor="let column of columnShowHideList; index as i">
        <mat-slide-toggle class="mat-menu" [(ngModel)]="column.isActive" (change)="toggleColumn(column)">
        </mat-slide-toggle>
        <span class="mat-menuList">
          {{ column.name }}
        </span>
        <br />
      </span>
    </mat-menu>
  </div>
  <mat-accordion>
    <mat-expansion-panel hideToggle [expanded]="panelOpenState">
      <div fxLayout="row wrap" fxLayoutGap="12px">
        <div fxFlex.gt-md="19" fxFlex.gt-lg="20" fxFlex="100">
          <mat-form-field>
            <mat-label>Status</mat-label>
            <mat-select class="filtres" required [value]="selectedStatus" (selectionChange)="applyStatusFilter($event)">
              <mat-option value="All" selected>Tous</mat-option>
              <mat-option value="{{newStatus}}">{{newStatus}}</mat-option>
              <mat-option value="{{inProgressStatus}}"> {{inProgressStatus}} </mat-option>
              <mat-option value="{{resolvedStatus}}"> {{resolvedStatus}} </mat-option>
              <mat-option value="{{integratedStatus}}"> {{integratedStatus}} </mat-option>
              <mat-option value=" {{completedStatus}} "> {{completedStatus}} </mat-option>
              <mat-option value=" {{canceledStatus}} "> {{canceledStatus}} </mat-option>
            </mat-select>
          </mat-form-field>
        </div>
        <div fxFlex.gt-md="19" fxFlex.gt-lg="25" fxFlex="100">
          <mat-form-field>
            <mat-label>Type</mat-label>
            <mat-select class="filtres" required [value]="selectedType" (selectionChange)="applyTypeFilter($event)">
              <mat-option value="All" selected>Tous</mat-option>
              <mat-option value="Task">Task</mat-option>
              <mat-option value="Bug">Bug</mat-option>
              <mat-option value="Feature">Feature</mat-option>
              <mat-option value="Remark">Remark</mat-option>
              <mat-option value="Item">Item</mat-option>
              <mat-option value="Action">Action</mat-option>
            </mat-select>
          </mat-form-field>
        </div>
        <div fxFlex.gt-md="19" fxFlex.gt-lg="25" fxFlex="100">
          <mat-form-field>
            <mat-label>Priorité</mat-label>
            <mat-select class="filtres" required [value]="selectedPriority"
              (selectionChange)="applyPriorityFilter($event)">
              <mat-option value="All" selected>Tous</mat-option>
              <mat-option value="Faible">Faible</mat-option>
              <mat-option value="Moyenne">Moyenne</mat-option>
              <mat-option value="Elevé">Elevé</mat-option>
            </mat-select>
          </mat-form-field>
        </div>
        <div fxFlex.gt-md="17" fxFlex.gt-lg="25" fxFlex="100">
          <mat-form-field>
            <mat-label>Date de début</mat-label>
            <input class="filtres" [max]="maxStartDate" matInput [matDatepicker]="startDatePicker"
              (dateChange)="applyDateFilter()" [(ngModel)]="startDate" readonly />
            <mat-datepicker-toggle matSuffix [for]="startDatePicker"></mat-datepicker-toggle>
            <mat-datepicker #startDatePicker></mat-datepicker>
          </mat-form-field>
        </div>
        <div fxFlex.gt-md="17" fxFlex.gt-lg="25" fxFlex="100">
          <mat-form-field>
            <mat-label>Date de fin</mat-label>
            <input class="filtres" [min]="minEndDate" matInput [matDatepicker]="endDatePicker"
              (dateChange)="applyDateFilter()" [(ngModel)]="endDate" readonly />
            <mat-datepicker-toggle matSuffix [for]="endDatePicker"></mat-datepicker-toggle>
            <mat-datepicker #endDatePicker></mat-datepicker>
            <mat-error *ngIf="errorEndDate">{{
              errorEndDateMessage
              }}</mat-error>
          </mat-form-field>
        </div>
        <div fxFlex.gt-md="1" fxFlex.gt-lg="25" fxFlex="100">
          <a matTooltip="Effacer les champs" class="reset-button" mat-icon-button (click)="resetFields()"> <mat-icon>youtube_searched_for</mat-icon>
          </a>
        </div>
      </div>
    </mat-expansion-panel>
  </mat-accordion>
  <table id="tasks-table" mat-table multiTemplateDataRows [dataSource]="dataSource">
    <ng-container matColumnDef="ID">
      <th mat-header-cell *matHeaderCellDef>ID</th>
      <td mat-cell *matCellDef="let element">
        <mat-chip-list>
          <mat-chip [ngClass]="getTypeClass(element.type)" selected>
            #{{ element.id }}
          </mat-chip>
        </mat-chip-list>
      </td>
    </ng-container>
    <ng-container matColumnDef="Type">
      <th mat-header-cell *matHeaderCellDef>Type</th>
      <td mat-cell *matCellDef="let element">
        <mat-chip-list>
          <mat-chip [ngClass]="getTypeClass(element.type)" selected>
            {{ element.type }}
          </mat-chip>
        </mat-chip-list>
      </td>
    </ng-container>
    <ng-container matColumnDef="Nom">
      <th mat-header-cell *matHeaderCellDef >{{'nom' | translate}}</th>
      <td mat-cell *matCellDef="let element">
        {{ element.name}}
      </td>
    </ng-container>
    <ng-container matColumnDef="Status">
      <th mat-header-cell *matHeaderCellDef>Status</th>
      <td mat-cell *matCellDef="let element">
        {{ element.status }}
      </td>
    </ng-container>
    <ng-container matColumnDef="Priorité">
      <th mat-header-cell *matHeaderCellDef>{{'priorité' | translate}}</th>
      <td mat-cell *matCellDef="let element">
        {{ element.priority }}
      </td>
    </ng-container>
    <ng-container matColumnDef="Date Début">
      <th mat-header-cell *matHeaderCellDef>{{'date de début' | translate}}</th>
      <td mat-cell *matCellDef="let element">
        {{ element.startDate | date }}
      </td>
    </ng-container>
    <ng-container matColumnDef="Date Fin">
      <th mat-header-cell *matHeaderCellDef>{{'date de fin' | translate}}</th>
      <td mat-cell *matCellDef="let element">
        {{ element.endDate | date }}
      </td>
    </ng-container>
    <ng-container matColumnDef="Temps Estimé">
      <th mat-header-cell *matHeaderCellDef>{{'temps estimé' | translate}}</th>
      <td mat-cell *matCellDef="let element">{{ element.estimatedTime }} H</td>
    </ng-container>
    <ng-container matColumnDef="Temps Passé">
      <th mat-header-cell *matHeaderCellDef>{{'temps passé' | translate}}</th>
      <td mat-cell *matCellDef="let element">{{ element.passedTime }} H</td>
    </ng-container>
    <ng-container matColumnDef="Réalisation">
      <th mat-header-cell *matHeaderCellDef>{{'réalisation' | translate}}</th>
      <td mat-cell *matCellDef="let element">
        <span><mat-progress-bar color="accent" mode="determinate" [value]="element.realisation"></mat-progress-bar>
          {{ element.realisation }} %</span>
      </td>
    </ng-container>
    <ng-container matColumnDef="Assigné à">
      <th mat-header-cell *matHeaderCellDef>{{'assigné à' | translate}}</th>
      <td mat-cell *matCellDef="let element">
        <div class="d-flex" *ngIf="element.user">
          <img class="mat-card-avatar" [src]="element.user.image" matTooltip=" {{ element.user.firstName }} {{
              element.user.lastName
            }}" />
        </div>
      </td>
    </ng-container>
    <ng-container matColumnDef="Actions">
      <th mat-header-cell *matHeaderCellDef><span>{{'actionTaskList' | translate}}</span></th>
      <td mat-cell *matCellDef="let element">
        <div fxLayoutGap="0px">
          <a mat-icon-button matTooltip="{{'lien ticket' | translate}}" (click)="getUrl(element.url)"
            [disabled]="!element.url"><mat-icon>link</mat-icon></a>
          <a mat-icon-button matTooltip="{{'modifier ticket' | translate}}" [href]="['/project/task/edit/' + element.id]"
            [disabled]="element.status === canceledStatus"
            *ngIf="hasPermission(editTasksPermission)"><mat-icon>edit</mat-icon></a>
          <a matTooltip="{{'ajouter un ticket enfant' | translate}}" mat-icon-button color="accent"
            [href]="['/project/task/add-child/'+ element.id]" [disabled]="element.status === canceledStatus"
            *ngIf="hasPermission(addChildTasksPermission)"><mat-icon>add_circle</mat-icon>
          </a>
          <a matTooltip="{{'consulter historique' | translate}}" mat-icon-button [routerLink]="['/project/task/trail', element.id]"
            *ngIf="hasPermission(trailTasksPermission)"><mat-icon>history</mat-icon>
          </a>
          <a mat-icon-button matTooltip="{{'supprimer ticket' | translate}}" color="warn" (click)="openDeleteDialog(element)"
            *ngIf="element.status === newStatus && hasPermission(deleteTasksPermission)"><mat-icon>delete_outline</mat-icon>
          </a>
          <a mat-icon-button matTooltip="{{'annuler ticket' | translate}}" color="warn" (click)="openCancelDialog(element)"
            *ngIf="element.status !== newStatus && element.status !== completedStatus && element.status !== canceledStatus && hasPermission(deleteTasksPermission)"><mat-icon>cancel</mat-icon>
          </a>
        </div>
      </td>
    </ng-container>

    <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
    <tr class="mat-row" *matNoDataRow>
      <td class="mat-cell" [attr.colspan]="displayedColumns.length">
        {{'noDataFound' | translate}}
      </td>
    </tr>
    <tr mat-row *matRowDef="let element; columns: displayedColumns"
      [ngClass]="{ 'gray-background': element.status === canceledStatus }"></tr>
  </table>
  <mat-paginator [pageSizeOptions]="[8, 16, 24, 32, 40, 48, 56, 64, 72, 80]" showFirstLastButtons></mat-paginator>
</div>
